/* Created by Sibin M on Oct 25, 2004.
 * Process of cleaning up the TA for C++
 */ 

#ifndef __DEPEND_H__
#define __DEPEND_H__

extern void host_info() ; ;
extern void set_vector_length( struct inf_func_element* inf ) ;
extern void block_constraints( struct inf_func_element* inf ) ;
extern char *salloc( int siz ) ;
extern void dinsert( dvector* sptr, unsigned int r ) ;
extern int din( dvector ptr, unsigned int r ) ;
extern void dinter( dvector* res, dvector ptr ) ;
extern void dunion( dvector* dresult, dvector dvec ) ;
extern void dminus( dvector* a, dvector b ) ;
extern void dcpy( dvector* dst, dvector src ) ;
extern int dcmp( dvector a, dvector b ) ;
extern void showdvect( dvector d ) ;
extern void block_constraints( struct inf_func_element* inf ) ;
extern void print_block_info( struct inf_func_element* inf, struct tnode* node_ptr ) ;
extern struct inst_num_node * find_inst_num( struct inst_num_node *head, int num ) ;
extern void init_branch_info( struct inf_func_element* inf, struct tnode* node_ptr ) ;
extern struct branch_node *lookup_branch( struct tnode* node_ptr, int number ) ;
extern void print_branch_info( struct tnode* node_ptr ) ;
extern void clear_branch_info( struct tnode* node_ptr ) ;
extern void set_branch_states( struct tnode* node_ptr, struct loop_block_list* block_ptr, struct block_element* block_element_ptr ) ;
extern int set_path_numbers( struct tnode* node_ptr ) ;
extern void print_path_num_list( struct path_num_node* number_list ) ;
extern void count_blocks( struct tnode* node_ptr ) ;
extern void infeasible_paths( struct inf_func_element* inf, struct tnode* node_ptr ) ;
extern void set_preheader_branch_states( struct inf_func_element* inf, struct tnode* node_ptr ) ;
extern int is_in_loop_block_list( int number, struct loop_block_list* list ) ;
extern int is_in_loop( int number, struct tnode* node_ptr ) ;
extern void path_influence( struct inf_func_element* inf, struct tnode* node_ptr ) ;
extern int can_imm_follow( struct loop_path_node* path_ptr1, struct loop_path_node* path_ptr2 ) ;
extern void create_imm_follow( struct tnode* node_ptr ) ;
extern void print_imm_follow( struct tnode* node_ptr ) ;
extern int is_dead_end( struct tnode* node_ptr, int number ) ;
extern int is_none( struct tnode* node_ptr, int number ) ;
extern int how_long_to_reach( struct tnode* node_ptr, int num1, int num2, int mask ) ;
extern void reachability( struct tnode* node_ptr ) ;
extern void print_path_reach( struct tnode* node_ptr ) ;
extern void find_unique_iters( struct tnode* node_ptr ) ;
extern void print_path_iters( struct tnode* node_ptr ) ;
extern int ranges_intersect( int a, int b, int c, int d ) ;
extern void compute_ranges( struct tnode* node_ptr ) ;
extern void print_range_list( struct tnode* node_ptr ) ;
extern void preheader_check( struct inf_func_element* inf, struct tnode* node_ptr ) ;
extern void first_turn( struct tnode* node_ptr ) ;
extern struct range_node *find_paths_range( struct tnode* node_ptr, struct loop_path_node* path_ptr ) ;
extern void check_exit( struct tnode* node_ptr ) ;
extern void find_compares( struct inf_func_element* inf, struct tnode* node_ptr, enum time_case tcase ) ;
extern bool common_fm( struct inf_func_element* inf, struct tnode* node_ptr, 
			struct loop_path_node* path_ptr, struct instruct* inf_inst_ptr ) ;
extern void infeasible_exit( struct inf_func_element* inf, struct tnode* node_ptr ) ;
extern void infeasible_transition( struct inf_func_element* inf, struct tnode* node_ptr ) ;
extern bool infeasible_continue( struct tnode* node_ptr, struct loop_path_node* path_ptr, enum time_case tcase ) ;
extern void print_path_types( struct tnode* node_ptr ) ;
	
#endif // __DEPEND_H__
