/*
*****************************************************************************
*
* 
*   FILE NAME       :   INST.H
*   PROGRAMMER(S)   :   Robert Arnold
*   DATE CREATED    :   July 3, 1993
*
*   LAST EDITED : Wed Apr 13 14:15:03 1994 by arnold (Robert Arnold) on grep
*
******************************************************************************
*
*   MODIFICATION HISTORY:
*
*   Date       Change				
*   --------   ----------------------------------------------------------------
*   02/10/94   Added "#define INST.H" for conditional compilation
*
******************************************************************************/

#ifndef __INST_H__
#define __INST_H__

#include "instdef.h"

#define INST_H
#define  MAX_STRING_LENGTH 1024



struct inst_block
{
  int                      num;                    /* number representing instruction */
  char                     inst[MAX_INST_LENGTH];     /* string representation of inst */
  char                     inst_class[MAX_STRING_LENGTH];
  struct inst_block        *next;
};



struct operand
{
  int                       data_type;
  char                      reg_list[MAX_STRING_LENGTH];
};

struct instruct
{  
  int                       number;                    /* inst # offset from
                                                            func beginning*/

  int			     prog_offset;	/* inst # from prog beginning*/
  int			     block_inst;		/* inst # in its block*/

  int                        PC;                  /*relative PC*/

  char                      inst[MAX_INST_LENGTH];     /* instruction name*/
  int                       inst_type;
  int                       data_type;
  int                       cond_code;
  char                      inst_class[MAX_STRING_LENGTH];
  struct operand            op1;
  struct operand            op2;
  struct operand            op3;
  char                      called_func[MAX_STRING_LENGTH];           /* called function name */
  struct instruct           *next;                     /* pointer to the next instruction */
};

#endif // __INST_H__ 
