/* Created by Sibin M on Oct 25, 2004.
 * Process of cleaning up the TA for C++
 */
 
#ifndef __ISA_H__
#define __ISA_H__

#include "timeds.h"

extern char *stage_name( int stage_number ) ;
extern int reg2int( char* reg ) ; 
extern void int2reg( int num, char* reg ) ; 
extern int is_flop( char* inst_name ) ;
extern int dest_in_op3( char* name ) ;
extern int is_load_inst( char* name ) ;
extern int is_store_inst( char* name ) ;
extern int is_branch( int opcode ) ;
extern int is_call( int opcode ) ;
extern struct cycle_jump_node *calc_cycle_jump( row *begin_use, row *end_use, 
					 int pipeline_cycles[], int num_path_inst ) ;
extern void weird_fix1( int* path_end_cycles, int cycle_diff, int* path_cycles) ;
extern int set_instr_size( struct instruct* inf_inst_ptr) ;
extern int dest_ready_stage( struct instruct* inf_inst_ptr, int inst_data_type ) ;
extern void set_src_needed( int* stage_src1_needed, int* stage_src2_needed,
			    int* stage_src3_needed, int num_path_inst, 
			    struct instruct *inf_inst_ptr) ;
extern int check_branch_misprediction( struct instruct* inf_inst_ptr, 
			        struct inst_num_node* inst_num_head ) ;
extern void branch_penalty_after_loop( int* earliest_start ) ;
extern void initialize_end_use( row* end_use, int num_path_inst,
			 int* this_inst_end_cycles ) ;
extern void add_misprediction_penalty( bool& prev_Mispredicted_branch, 
			        row* end_use, int num_path_inst ) ;
extern void calculate_end_use( int* this_inst_end_cycles, row* end_use, row* begin_use,
		        int num_path_inst, int only_fetch, int* inst_cond_code, 
		        int* cc_set, int* inst_data_type, 
		        struct instruct* inf_inst_ptr, int size, int tcase ) ;
extern void data_access( struct instruct * inf_inst_ptr, int * this_inst_end_cycles, 
		  int * this_inst_beg_cycles, int data_status, int *dcache_misses,
		  struct instr_history * history, bool& prev_MEM_Miss, 
		  int DC_MISS_LATENCY) ;		  
extern void add_data_hazard_penalty(int delay,int * this_inst_end_cycles, int *end_use,
			struct instruct *inf_inst_ptr) ;
extern void calculate_begin_use(int *begin_use, int *end_use, int * this_inst_end_cycles) ;
extern void calculate_cc_reg(int *inst_cond_code, int *inst_data_type,int *src_needed, 
		 int *end_use, int *release_time) ;
extern bool check_update_variable_cycles( int opcode, int this_inst_end_cycles[], int iterations_handled, int max_iterations ) ;
extern int adjust_for_variable_cycles( struct inf_func_element* inf, 
				struct loop_path_node* path_head, 
				struct loop_path_node* longest_path_ptr,
				struct union_list_node* end_head[], 
				struct union_list_node* prev_end_head[],
				int path_cycles, int max_pipeline ) ;
extern int get_cycles(row *end_use,int  num_path_inst, int only_fetch) ;
extern void  print_inst_time(row *begin_use,row * end_use,int num_path_inst,
		      int * path_pipeline) ;
extern void print_table_head() ;
extern void update_end_use(row *end_use,int num_path_inst,int * this_inst_end_cycles) ;
extern int ex_time( int inst, int size, enum time_case tcase) ;

#endif // __ISA_H__
