/* Created by Sibin M on Oct 25, 2004.
 * Process of cleaning up the TA for C++
 */

#ifndef __LIB_H__
#define __LIB_H__

extern struct block_list * Create_Block_List( int block_number ) ;
extern void Append_Block_Blocklist( int block_number, struct block_list **path ) ;
extern void Delete_Blocklist( int block_number, struct block_list **list ) ;
extern bool Is_In_Block_List( int block_number, struct block_list *list ) ;
extern void Add_Block_To_Cache_List( int line_number, int inst_number, 
			      int instance, char best_case, 
			      char worst_case, struct category_list *cat_list,
			      struct cache_block **list ) ;
extern struct cache_block * Create_Cache_Block( int line_number, int inst_number,
					 int instance, char best_case, char worst_case, 
					 struct category_list *cat_list ) ;
extern int cache_blocks_match( struct cache_block* list1, struct cache_block* list2 ) ;
extern void Copy_Cache_List( struct cache_block** target_list, 
		      struct cache_block* source_list ) ;
extern void Print_Cache_Block( struct cache_block* cblock ) ;
extern void Print_Cache_List( struct cache_block* cblock_list ) ;
extern void Union_Cache_List( struct cache_block** target_list, 
		       struct cache_block* source_list ) ;
extern void Update_Cache_Block( struct cache_block* cache_block ) ;
extern void Update_Cache_List( struct cache_block* cache_list ) ;
extern bool transition( char from, char to, 
			 struct cache_block* cache_block,
			 enum time_case tcase ) ;
extern int Determine_Num_Still_SomeMiss( struct cache_block* pcache_list, 
				  struct cache_block* ccache_list, 
				  enum time_case tcase ) ;
extern int Determine_Num_New_Miss2Hit( struct cache_block* pcache_list, 
				struct cache_block* ccache_list,
				enum time_case tcase ) ;
extern int Determine_Num_FirstMiss_FM_Trans( struct cache_block* pcache_list, 
				      struct cache_block* ccache_list,
				      enum time_case tcase,
				      int* fut_trans ) ;
extern bool ever_transition( char from, char to, 
			      struct category_list* clist, 
			      enum time_case tcase ) ;
extern bool SomeMiss_FirstHit_Trans( struct category_list *clist, 
				      enum time_case tcase ) ;
extern bool Matching_Cache_Blocks( struct cache_block *block1, 
				    struct cache_block *block2 ) ;
extern bool Inst_In_Cache( struct cache_block* fm_list, int line_number ) ;
extern struct category_list * Create_Category_List( char best_case, char worst_case ) ;
extern void Copy_Category_List( struct category_list** target, 
			 struct category_list* source ) ;
extern void Print_Category_List( struct category_list* clist ) ;
extern void Print_Cat_List( struct category_list* cat_list ) ;
extern bool Inst_Same_Cache_Line( struct inst_cat* inst1_ptr, 
				   struct inst_cat* inst2_ptr ) ;
extern struct block_element * Create_Block_Element( int block_number ) ; /* assigned by vpo */
extern struct inf_func_element * Create_Inf_Func_Element( string name, 
						   int number, 
						   string filename ) ;
extern struct inst_block * Create_Inst_Block( int inst_num, char inst[MAX_INST_LENGTH] ) ;
extern int Find_Max_Inst( struct instruct* inst_list ) ;
extern struct instruct * Create_Instruct( int number, string inst, int inst_type,
				   int data_type, int cond_code, int op1_data_type,
				   string op1_reg_list, int op2_data_type, 
				   string op2_reg_list, int op3_data_type,
				   string op3_reg_list, string called_func ) ;
extern int Find_Last_Inst_Num( struct instruct* inst_list ) ;
extern struct loop_element * Create_Loop_Element( int number, int nest_level,
					   int min_iterations, int max_iterations,
					   int abs_min_iterations, int abs_max_iterations,
					   int induction_init, int induction_limit,
					   int lower_bound, int upper_bound, int header ) ;
extern struct loop_element * Find_Loop ( struct inf_func_element* inf_ptr,
				  int header_block ) ;
extern struct loop_node * Create_Loop_Node( int number, int block_number,
				     int nest_level, int min_iterations, 
				     int max_iterations, int abs_min_iterations, 
				     int abs_max_iterations ) ;
extern struct loop_block_list * Create_Loop_Block_List( int block_number, 
						 bool is_loop_node,
						 struct loop_node* node_ptr ) ; 
extern bool Is_Same_Loop_Path( struct loop_block_list* path1, 
				struct loop_block_list* path2 ) ;
extern void Append_Block_Pathlist( int block_number, 
			    struct loop_node* loop_node_list, 
			    struct loop_block_list* path ) ;
extern struct loop_block_list * Copy_Loop_Block_List( struct loop_block_list* list ) ;
extern struct loop_path_node * Create_Loop_Path( int block_number ) ;
extern struct path_element * Create_Path_Element( int block_number,
					   struct loop_node* func_loop_ptr ) ;
extern struct loop_block_list * Find_Prev_Path_Block( int curr_block, 
					       struct loop_block_list* path_list ) ;
extern void Append_Block_Path( int block_number, 
			struct loop_node* loop_node_list, 
			struct path_element* path ) ;
extern struct loop_node * Loop_Node_Ptr_Addr( int block_number,
				       struct loop_node* loop_node_list ) ;
extern bool Multiple_Blocks_In_Blocklist( struct block_list* list ) ;
extern struct block_list * Find_Pred_Blocklist( struct block_element*func_inf_ptr, 
					 int block_number ) ;
extern struct loop_path_node *  Copy_Loop_Path_Node_List( struct loop_path_node* list ) ;
extern struct path_element * Copy_Path_List( struct path_element* path, struct loop_node* func_loop ) ;
extern struct block_element * Locate_Inf_Block( struct inf_func_element* inf, 
					 int block_number ) ;
extern int Min( int int1, int int2 ) ;
extern void dump_INF(struct inf_func_element *myinf) ; 
extern int larger( int a, int b ) ;

#endif // __LIB_H__
