/* Created by Sibin M on Oct 25, 2004.
 * Process of cleaning up the TA for C++
 */ 

#ifndef __TIME_DECL_H__
#define __TIME_DECL_H__

extern int ttime() ;
extern void adjust_instcats( struct tnode* root ) ;
extern void adjust_firstmisses( struct tnode* root ) ;
extern void adj_more_fm( struct tnode* root ) ;
extern void Batch_Time( struct tnode* root ) ;
extern bool All_Children_Timed( struct tnode* node_ptr ) ;
extern void Time_Worst_Case( struct inf_func_element* inf, struct tnode* node_ptr ) ;
extern void Time_Best_Case( struct inf_func_element* inf, struct tnode* node_ptr ) ;
extern int Time_Path( struct inf_func_element* inf, struct tnode* node_ptr, 
	       struct loop_path_node* path_ptr, struct cache_block** fm_list, 
	       struct cache_block** fh_list, enum time_case tcase,
               enum cache_access fm_status, enum cache_access fh_status, 
	       int beg_block, int end_block, int beg_inst, int end_inst, int data_status ) ;
extern struct tnode * Locate_Child_Loop_Header( int header, struct tnode* root ) ;
extern struct inst_cat * Locate_Stats_Inst( struct inst_cat* inst_list, int inst_number ) ;
extern void error( char* msg ) ;
extern void poss_update( int* a, int b, char* message ) ;	/* assign a = b if b > a */
extern void print_array( int array[], int initial, int howmany, char* message ) ;
extern void global_info( char c ) ;
extern void print_components( int iterations, int time, int extra_fh, int extra_fm, int shared_fm,
              	       int first_line_delay, int delay_after_fm, int last_line_delay, 
		       int fm_dead_cycles ) ;
extern void print_union( struct union_list_node * beg_head[], struct union_list_node * end_head[] ) ;
extern void print_path_fields( struct loop_path_node* path_ptr, enum time_case tcase ) ;
extern void find_reg_delay( int* delay, int union_release_time[], int union_src_needed[] ) ;
extern void read_delays() ;
extern int count_from_end( struct instruct* instruct_ptr ) ;
extern int *get_inst_word_list( struct instruct* instruct_ptr ) ;
extern struct cache_block *find_fm_cblock( int fm_inst_number, struct cache_block* fm_list ) ;
extern void print_delay_after_fm_list( struct delay_after_fm_node* head ) ;
extern void print_inst_num_list( struct inst_num_node* head ) ;
extern void print_cache_info( struct loop_path_node* longest_path_ptr ) ;
extern int need2calculate( struct loop_path_node* path_ptr, struct cache_block* fm_list, 
		    struct cache_block* fh_list, enum cache_access fm_status,
		    enum cache_access fh_status ) ;
extern int incr_new_total_time( int prev_total, int* prev_end, int* this_beg, int* this_end ) ;
extern int compare_equations (int i1, int m1, int i2, int m2,int *COND) ; 
extern int poss_update_equations (int *i1, int *m1, int i2, int m2) ; 
extern int eq_merge (int *m1, int *i1, int m2, int i2) ; 
extern int max(long a, long b) ; 

/* Added by Sibin M on Mar 31, 2005. 
 * Adding handling of parametric TA.
 */
#ifdef __PARAMETRIC_TA__
char *fix_poly_string( char* old_poly_str, char* old_var_list, char* new_var_list, struct tnode* node) ;
void createEvals(int argc, char* argv[], struct tnode* programTree, struct inf_func_element* inf) ;
#endif // __PARAMETRIC_TA__
/* Added by Sibin M on Mar 31, 2005. 
 * Adding handling of parametric TA.
 */

#endif // __TIME_DECL_H__
