/* Created by Sibin M on Oct 25, 2004.
 * Process of cleaning up the TA for C++
 */ 

#ifndef __TREE_DECL_H__
#define __TREE_DECL_H__

#include "tree.h"

// #include <fstream>
#include <cstdio>

extern void Build_Timing_Tree( struct inf_func_element* inf, string inputfile, 
			struct tnode** timing_tree, struct tnode** main_func ) ;
extern void Create_Tree( struct tnode* timing_tree ) ;
extern struct tnode * Locate_Func_Node( struct tnode *root, string node_name, 
				 int instance ) ;
extern struct tnode * Process_STATS_File( string inputfile, struct inf_func_element* inf ) ;
extern struct tnode * Create_Tnode( string name, int instance, 
			     enum tnode_type node_type, 
			     int loop_header_block, 
			     struct inf_func_element* inf ) ;
extern struct exit_block * Create_EBlock( int eblock ) ;
extern struct worst_case_timing * Create_Worst_Case_Timing() ;
extern struct best_case_timing * Create_Best_Case_Timing() ;
extern struct inst_cat * Create_Inst_Cat( int inst_number, 
				   int loop_number, 
				   struct category_list* cat_list, 
				   int line_number, string called_func,
				   int instance ) ;
extern void Create_Loops( struct tnode* func ) ;
extern struct block_list * Determine_EBlock_List( struct tnode* node_ptr ) ;
extern int Determine_Max_Nest_Level( struct loop_element *inf_loop_list ) ;
extern struct inf_func_element * Locate_Inf_Func( struct tnode *tnode_ptr, 
 					          struct inf_func_element *inf_ptr ) ;
extern struct loop_node * Locate_Loop_Paths( int loop_header_block, struct inf_func_element *inf_ptr ) ;
extern struct tnode * Locate_Main( struct tnode* timing_tree ) ;
extern struct tnode * Locate_Parent_Node( int nest_level, int header, struct tnode* func ) ;
extern struct tnode * Locate_Child_Node( string name, int instance, struct tnode* node_ptr ) ;
extern void Read_Inst_Categories( FILE *stats_fp, int *file_status,
				  int *number, struct tnode *tnode_ptr ) ;
extern struct tnode * Search_Tree_For_Loop_Node( struct tnode* root, string loop_name ) ;
extern void Search_Tree( string loop_name, struct tnode *root, struct tnode **node_ptr ) ;
extern void Add_Child_Node( struct tnode *parent_ptr, struct tnode *tnode_ptr ) ;
extern void Move_Inst_To_Correct_Loop_Nodes( struct tnode* func ) ;
extern void reverse( char* s ) ;
extern void itoa( int n, char* s ) ;
extern void Print_Results( struct tnode * func ) ;
extern void Print_Parameters( struct tnode* func ) ;
extern void Print_Tree( struct tnode* func ) ;
extern void Print_Parameter_Tree( struct tnode* func ) ;
extern void Print_Debug( struct tnode* func ) ;
extern void Peek_At_Tree(struct tnode * func) ; 

#endif // __TREE_DECL_H__
