%token PLUS
%token MINUS
%token MULTIPLICATION
%token INTEGER
%token OPEN_PAREN
%token CLOSE_PAREN

%start A
%%
A 	: A PLUS M
	{
		EVAL_VERBOSE("A -> A + M reduced.\n");
		$$ = $1 + $3;
		answer = $$;
		EVAL_VERBOSE("answer: %d\n", answer);
		EVAL_VERBOSE("$$: %d\n", $$);
		EVAL_VERBOSE("$3: %d\n", $3);
	}
 	| A MINUS M
	{
		EVAL_VERBOSE("A -> A - M reduced.\n");
		$$ = $1 - $3;
		answer = $$;
		EVAL_VERBOSE("answer: %d\n", answer);
		EVAL_VERBOSE("$$: %d\n", $$);
	}
	| M
	;

M	: M MULTIPLICATION P
	{
		EVAL_VERBOSE("M -> M + P reduced.\n");
		$$ = $1 * $3;
		answer = $$;
		EVAL_VERBOSE("answer: %d\n", answer);
		EVAL_VERBOSE("$$: %d\n", $$);
	}
	| P
	;
P	: OPEN_PAREN A CLOSE_PAREN
	{
		EVAL_VERBOSE("P -> ( A ) reduced.\n");
		$$ = $2;
		answer = $$;
		EVAL_VERBOSE("answer: %d\n", answer);
		EVAL_VERBOSE("$$: %d\n", $$);
	}
	| INTEGER
	{
		EVAL_VERBOSE("P -> INTEGER\n");
		$$ = $1;
		answer = $$;
		EVAL_VERBOSE("answer: %d\n", answer);
		EVAL_VERBOSE("$$: %d\n", $$);
	}
	;
%%

#include "../debug.h"

char *expression;
extern char *yytext;
extern int yylex();
extern int where_was_i;
int answer;

int yyerror(char *error)
{
	return -1;
}

void reset_lexer_state()
{
	where_was_i = 0;
}

int mtadel_eval(char *to_eval)
{
	/* since we are parsing a new expression, we want the lexer to 
	begin by looking at the start of the string. Therefore, set where_was_i to 0. 
	See lexer.c for more information about where_was_i. */
	reset_lexer_state();
	/* initialize the global variable designated to hold the expression to be evaluated
	to the correct expression. */
	expression = to_eval;
	/* initialize the global variable that will hold the numeric evaluation of this expression. */
	answer = 0;
	
	/* even though the name of this function is odd, calling this will
	actually evaluate _expression and store the numeric answer is _answer. */
	yyparse();
	EVAL_VERBOSE("answer: %d\n", answer);
	return answer;
}
