#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "debug.h"

char *mtadel_reverse(char *);

/* ============================
mtadel_itoa(n)

converts the parameter _n into a
	string.
   ==========================*/
char *mtadel_itoa(int n)
{
	char *tmp = NULL, *ret;
	char t = ' ';
	int i = 0;
	do 
	{
		t = (char)((n % 10) + '0' );
		if (tmp == NULL)
		{
			tmp = (char*)malloc(2);
			memset(tmp, 0, 2);
			tmp[i] = t;
		}
		else
		{
			I_VERBOSE("before realloc in mtadel_itoa()\n");
			tmp = realloc(tmp, strlen(tmp) + 2);
			I_VERBOSE("after realloc in mtadel_itoa()\n");
			tmp[i] = t;
			tmp[i+1] = '\0';
		}
		i++;
	} while ( (n /= 10) != 0);

	I_VERBOSE("tmp: %s\n", tmp);
	ret = mtadel_reverse(tmp);
	free(tmp);
	return ret;
}

/* ============================
mtadel_reverse(n)

create the reverse of _to_reverse and 
	return that string.
	This is useful for mtadel_itoa()
	since it creates the string
	version of the number in reverse.
   ==========================*/
char *mtadel_reverse(char *to_reverse)
{
	int to_rev_len = strlen(to_reverse);
	char *ret;
	int i, j;

	I_VERBOSE("to_rev_len: %d\n", to_rev_len);

	ret = (char*)malloc(to_rev_len + 1);
	memset(ret, 0, to_rev_len + 1);
	i = to_rev_len - 1;
	j = 0;
	for (; i>=0; i--, j++)
	{
		ret[j] = to_reverse[i];
	}
	return ret;
}
/*
//testing driver. Only uncomment when running 'make mtadel_itoa_test'
int main()
{
	I_VERBOSE("-%s-\n", mtadel_itoa(1));
	return 1;
}
*/
