#ifndef __TRACER_H__
#define __TRACER_H__

#include <iosfwd>
#include <string>
#include <sstream>
#include <vector>

class Tracer
{
	public :
		Tracer( const std::string& to_print, bool new_scope = true ) ;
		Tracer( const char* to_print, bool new_scope = true ) ;
		~Tracer() ;

		Tracer& operator << ( int to_print ) ;
		Tracer& operator << ( const std::string& tp_print ) ;
		Tracer& operator << ( const char* to_print ) ;
		Tracer& operator << ( double to_print ) ;

		static void stream( std::ostream* out ) ;
		static int numSpaces( int num_spaces ) ;

	private :
		static int _indent_level ;
		static int _num_spaces ;
		static std::ostream* _out ;
		bool _new_scope ;
		std::stringstream _printed ;
} ;

#endif // __TRACER_H__
