/*
 * Driver module for the timing analyzer.  Here, we set up the
 * interface with Prolog so we can make use of Ctadel.  4/8/99
 */
#include <cstdio>
#include <sys/time.h>
#include <sys/resource.h>
#include <cunistd>

/*#ifndef PL_OLD_INTERFACE
#define PL_OLD_INTERFACE
#endif
*/
#include "SWI-Prolog.h"

#define READLINE 1                      /* use readline interface */

PL_extension predicates[] =
{
/*{ "name",     arity,  function,       PL_FA_<flags> },*/

  { NULL,       0,      NULL,           0 }     /* terminating line */
};


#ifdef READLINE
static void
install_readline(int argc, char**argv)
{ PL_install_readline();
}
#endif

char *eval();

main(int argc, char **argv)
{
struct rlimit mytest;

getrlimit(RLIMIT_STACK, &mytest);
mytest.rlim_max = RLIM_INFINITY;
setrlimit(RLIMIT_STACK,&mytest);

#ifdef READLINE
  PL_initialise_hook(install_readline);
#endif

  PL_register_extensions(predicates);   /* This is the only PL_ call allowed */
                                        /* before PL_initialise().  It */
                                        /* ensures the foreign predicates */
                                        /* are available before loading */
                                        /* Prolog code */

  /*
   * Used to hang when I passed argc as first argument, sometimes with
   * several command-line arguments as in "time.bin -co -iv -tr fresnel2"
   * So instead pass 0 as the first argument.  4/29/99
   */
  if ( !PL_initialise(0, argv) )
    PL_halt(1);				/* Prepare to use Prolog/Ctadel */

  time_main(argc, argv);

  PL_halt(0);				/* no longer need to use Prolog */
}
