#include "CFG.h"
#include "assert.h"

#include <cstdlib>
#include <string>

// #define __SIB_DEBUG__

/*ASSUMPTION - Rd = Rd ... Rs = Rr, ...Rt = R? 
               I/O register = Fd.. fs:ft used for high:low regs*/

/*read the prologue code in assembly file */
void read_initialize(FILE *in, FILE *out) {
  char str[MAXSTR], str1[MAXSTR], dummy[MAXSTR],dummy1[MAXSTR],ch;
  while ((fgets(str,MAXSTR,in)) != NULL) {
    compress_whitespace(str);
    if (out != NULL)
      fprintf(out,"%s",str);

    if (!strncmp(str,".type",5)){
      sscanf(str,"%s %[^,]%c%s",dummy,dummy1,&ch,str1);
      //printf ("debug %s %s %s %c %s\n",str,dummy, dummy1,ch,str1);
      if (!strncmp(str1,"@function",9))  break;
    }
    
  }
}


/*read block goes through the assembly and finds basic blocks*/
/*mybuffy is the label that ended previous basic block (should be
  included in new BB. mytarget and mylabel are self explanatory*/

/*Assumption- labels are on line by themselves */
struct line *read_block(FILE *in, char *mybuffy, char * mylabel, 
			char *mytarget, int * myinst, int *NEWFUNC){

  struct line *ret_line, *rtls;
  char str[MAXSTR], c, *temp, dummy[MAXSTR];
  int leave = FALSE;
  int SPECIAL = FALSE;
  char * wtf;


  ret_line = rtls = NULL;
  *myinst = 0;

  while ((fgets(str,MAXSTR,in)) != NULL) {

    /*remove excess whitespace*/
    compress_whitespace(str);
    /*if line contains only whitespace  it is ignored */
    if ((str[0] == '\0')||(str[0] == '/')||(str[0] == '#')) continue;
    


    /*The special case ". *" after return must not be in a new BB
      takes care of the*/
    if (SPECIAL) {
      rtls->next = (struct line *) malloc(sizeof(struct line));
      if (rtls->next == NULL)
	error("out of heap memeory for lines");
      rtls = rtls->next;
      strcpy(rtls->str, str);
      rtls->next = NULL;
      if (str[0] == '.') {
	continue;
      }
      else{
	*NEWFUNC = TRUE;
	strcpy(mybuffy, str);
	return ret_line;
      }
    }


    /*If previous BB ended because of a label... get current label name*/
    if (ret_line == NULL) {
      if (mybuffy[0] != '\0') {
	strcpy(mylabel, mybuffy);
	rtls = ret_line = (struct line *) malloc(sizeof(struct line));
	if (ret_line == NULL)
	  error("out of heap memeory for lines");
	strcpy(rtls->str, mybuffy);
	rtls->next = NULL;
	mybuffy[0] = '\0';
      }
      else mylabel[0] = '\0'; 
    }


    /*if a label is reached... stop basic block and save
      label name for the next basic block*/
    if ((index(str,LABEL_TERM)) !=NULL) {
      if (ret_line) {
	strcpy(mybuffy, str);
	mytarget[0] = '\0';
	return ret_line;
      } else { /*however if this is a new BB starts with label store it */
	rtls = ret_line = (struct line *) malloc(sizeof(struct line));
	if (ret_line == NULL)
	  error("out of heap memeory for lines");
	strcpy(rtls->str, str);
	rtls->next = NULL;
	strcpy(mylabel, str);
	continue;
      }
    } else { /*if no label .. count as instruction*/
      mybuffy[0] = '\0';
      if (str[0] != '.') (*myinst)++;
    }



    /*BB ends if there is a branch instruction.... */
    if ((!strncmp(str,"br",2)) && (strncmp(str,"break",5))) {
      if (index(str,'.')) strcpy(mytarget, index(str,'.'));
      else {
	printf("str is : %s\n",str);
	error("target of branch BAD\n");
      }
      leave = TRUE;
      
    }
    else if( !( strncmp( str, "sbrc", 4 ) ) || !( strncmp( str, "sbrs", 4 ) ) || 
	     !( strncmp( str, "sbic", 4 ) ) || !( strncmp( str, "sbis", 4 ) ) ) 
    {
      /* Added by Sibin M on March 11, 2004.
       * Added checks for the "sbrs", "sbrc", "sbic", "sbic", all
       * of which are supposed to be exits from the Basic Block.
       */
      leave = TRUE ;
      mytarget[0] = '\0' ;
    }
    else if (strstr(str,"ret")) 
    {
      SPECIAL = TRUE;
      mytarget[0]='\0';

    } 
    else if (strstr(str,"jmp")) 
    {
      /* Modified by Sibin M on March 11, 2004.
       * Added in the condition for "jmp exit" 'cos ncc doesn't use "rjmp" .
       */
      if (!strncmp(str, "rjmp __stop_progIi__",20) ||
	  !strncmp(str, "rjmp exit",9) ||
	  !strncmp(str, "jmp exit", 8) ) 
      {
	SPECIAL = TRUE;
	if (ret_line){
	  rtls->next =  (struct line *) malloc(sizeof(struct line));
	  rtls = rtls->next;

	} else {
	  rtls = ret_line = (struct line *) malloc(sizeof(struct line));

	}
	rtls->next = NULL;
	strcpy(rtls->str,"ret\n");
	mytarget[0]='\0';
	continue;
	  
      }else if (str[0] != 'i') {
	if (!index(str,'.')) {
	  printf("str is : %s\n",str);
	  error("target of branch BAD\n");
	}
	
	sscanf(str,"%s %s ",dummy, mytarget);
	leave = TRUE;
      } else {
	error("INDIRECT JUMP ENCOUNTERED \n");
      } 
     
    } else if (strstr(str,"call")) {
      if (str[0] != 'i') {
	/*SPECIAL CASE OF addsf3*/
	/* The following added by Sibin M on April 03, 2004. 
	 * To also include "call __" as a dummy function. Atemga103 uses "call" instead of "rcall"
	 * The second strncmp was the new addition.
	 */ 
	if ( !strncmp( str, "rcall __", 8 ) || !strncmp( str, "call __", 7 ) ) {
	  printf("CALLING UNKNOWN FUNCTION: %s\n",str);
	  strcpy(str,"sbrc r1,0\n");
	} else {
	  sscanf(str,"%s %s ",dummy, mytarget);
	  leave = TRUE;
	}
      } else {
	error("INDIRECT CALL ENCOUNTERED \n");
      }
    }

    /*the skip instructions do not end the BB (?)*/
    /* else if (!strcmp(str,"sbrc") || !strcmp(str,"sbrs")) {

    } else if (!strcmp(str,"sbic") || !strcmp(str,"sbis")) {
	
    } else if (!strncmp(str,"cpse",4)) {

    }*/

      
    /*alloc new line stuct and fill it in all other cases*/
    if (ret_line == NULL) {
      rtls = ret_line = (struct line *) malloc(sizeof(struct line));
      if (ret_line == NULL)
	error("out of heap memeory for lines");
    }
    else {
      rtls->next = (struct line *) malloc(sizeof(struct line));
      if (rtls->next == NULL)
	error("out of heap memeory for lines");
      rtls = rtls->next;
    }

    strcpy(rtls->str,str);
    rtls->next = NULL;
    if (leave == TRUE)  return (ret_line);

  }

  mytarget[0] = '\0';
  return (ret_line);
}



/*
 * read_instrs - extract instruction info from the line input
 */

struct instr * read_instrs(struct temp_inst *head, struct line * rtls, int id, int *num_inst) {
  struct instr *top,*cur, *temp;
  struct line * ptr;
  struct temp_inst *curptr;
  char dummy[MAXSTR], *ch;
  curptr = NULL;
  top = cur = temp =  NULL;
  ptr = NULL; ch = NULL;

  for (ptr = rtls; ptr; ptr = ptr->next) {
    if (index(ptr->str,LABEL_TERM)!=NULL) continue;/*not instruction is label*/
    /*    if (index(ptr->str,'!')!=NULL) continue;*/

    if ((ch = index(ptr->str,'.'))!=NULL) 
      if (ch == ptr->str) continue;/*not instruction if comment like thing*/
    
    if (top) {/*add the new instr structure*/

      cur->next = (struct instr *) malloc(sizeof(struct instr));
      if (cur->next ==NULL) error ("out of heap memory for instr");
      cur = cur->next;
    }
    else {
      top = cur = (struct instr *) malloc(sizeof(struct instr));
      if (cur ==NULL) error ("out of heap memory for instr");
    }
    
    cur->BBid = id;
    cur->opcode=0;
    cur->str[0]='\0';
    cur->rs[0]='\0';
    cur->rt[0]='\0';
    cur->rd[0]='\0';  
    cur->fs[0]='\0';  
    cur->ft[0]='\0';  
    cur->fd[0]='\0';  
    cur->imm=0;
    cur->offset[0]='\0';
    cur->target[0] ='\0';
    cur->next = NULL;
    cur->cc = 0;

    sscanf(ptr->str,"%s",cur->str); 
    
    /*depending on the opcode... read the operands*/
    for (curptr = head; curptr; curptr = curptr ->next) {
      if (!strcmp(curptr->str, cur->str)) cur->opcode = curptr->opcode;
    }
	

    if ((cur->opcode >= 29 && cur->opcode < 33)||
	     (cur->opcode >= 47 && cur->opcode < 65)){
      sscanf(ptr->str,"%s %s ",dummy,cur->target);

    }
  }

  return top;
}


/* make cfg for the assembly */
void make_cfg(struct bblock *top) {
  struct bblock *cblk; /* current block */
  struct bblock *tblk; /* target block */
  struct line *rtl, *rtl1; /* line */


  for (cblk = top; cblk; cblk = cblk->next) {
    /*
     * find jump
     */
    if ((cblk->target[0] != '\0') && (index(cblk->target,'.') != NULL))
      find_target(cblk, top, cblk->target);
    /*The following is for deciding what to do with 
      unconditional jumps */
    for (rtl = cblk->rtls; rtl; rtl = rtl->next)
      if (((rtl->str[0] != '#') || (rtl->str[0] != '/')) &&
 	  (strstr(rtl->str,"jmp")!=NULL)) 
	break;

    /*    for (rtl1 = cblk->rtls; rtl1->next; rtl1 = rtl1->next) ;*/


    /* The following condition added in by Sibin M on Mar. 11, 2004.
     * If the last instruction in the block happens to be one of :
     * "sbrs", "sbrc", "sbis", "sbic"
     * then the next block as well as IT's next block are successors to this block.
     */

    // Find the last Line in the BBLock.
    for( rtl1 = cblk->rtls ; rtl1->next ; rtl1 = rtl1->next ) ;
    
    if( strstr( rtl1->str, "sbrs" ) || strstr( rtl1->str, "sbrc") ||
        strstr( rtl1->str, "sbis" ) || strstr( rtl1->str, "sbic") )
    {
	    if( cblk->next && cblk->next->next && !rtl )
    	    {
	    	cblk->succs = add_blist( cblk->succs, cblk->next ) ;
	    	cblk->succs = add_blist( cblk->succs, cblk->next->next ) ;
	    	cblk->next->preds = add_blist( cblk->next->preds, cblk ) ;
	    	cblk->next->next->preds = add_blist( cblk->next->next->preds, cblk ) ;
    	    }
	    else
           {
	   	/* Error !
	     	 */
	    	printf( "CFG Incorrect ! 'sbrc', 'sbrs', 'sbic', 'sbis' does not have correct successors !" ) ;
           }

	   // Don't execute the next condition. These blocks have already been added to the Preds and Succs lists.
	   continue ;
    }
    /* End Addition : Sibin M. Mar. 11, 2004.
     */

    /* The following condition added by Sibin M on Mar. 18, 2004.
     * If the last instruction in the block happens to be :
     * A branch instruction, and the target happens to be ".+2", 
     * then the next block as well as IT's next block are successors to this block.
     * The next block has already been added to the successors list, but add it's successor.
     */
    if( ( !strncmp( rtl1->str, "br", 2 ) ) && ( strncmp( rtl1->str, "break", 5 ) ) ) 
    {
#ifdef __SIB_DEBUG__
	    printf( "Here. Branch found\n" ) ;
#endif // __SIB_DEBUG__	   
	    // now, check to see if the target of the branch is ".+2"
	    if( !strcmp( cblk->target, ".+2" ) )
	    {
#ifdef __SIB_DEBUG__
	    	    printf( "Target of Branch = %s\n", cblk->target ) ;
#endif // __SIB_DEBUG__	   
		    // Make the second succeeeding block the successor of this block.
		    cblk->succs = add_blist( cblk->succs, cblk->next->next ) ;
		    cblk->next->next->preds = add_blist( cblk->next->next->preds, cblk ) ;
	    }
    }
    /* End Addition : Sibin M. Mar. 18, 2004.
     */

    /* Must decide if the next block is a successor or not
     * successor if this BB ends in "return",".something" or "call"
     */
    if (cblk->next && !rtl) {
      cblk->succs = add_blist(cblk->succs, cblk->next);
      cblk->next->preds = add_blist(cblk->next->preds, cblk);
    }
    
  }

}



/*The func to get the path info */
void path_info(FILE *outpath, struct bblock *top) {
   struct bblock *currblk;
   struct blist *succs;
   int state = FUNC;
   char funcname[MAXSTR], calledf[MAXSTR];
   int thispath,loopno = 0, loopfreq = 0, instoffset, numinst;
   int call = FALSE, nextpath1, nextpath2;
   int temp;
   static int offset = 0;

   /*write path info for each function....*/
   for (currblk=top; currblk; currblk = currblk->next) {
     call = FALSE;
     /*the following piece of code is useless if we write path info one func
       at a time*/
     /*          if (state == OTHER) {
		 if (currblk->label[0] != '\0')
		 if (index(currblk->label,'$') == NULL) {
		 state = FUNC;
		 }
		 }
     */
     thispath = instoffset = numinst = nextpath1 = nextpath2 = 0;
     /*copy top.. and modify for .end statements */

     switch(state) {
       
     case FUNC: { /*print out the func info  and entry path*/
       if (index(currblk->label,'.') != NULL) {
	 printf("CFG screwed up\n");
	 break;
       }
       else {
	 strcpy(funcname,currblk->label);
	 thispath = currblk->nr;
	 instoffset = offset;
	 numinst = currblk->num_inst;
	 offset += (numinst * 4);
	 loopno = currblk->loopno;
	 loopfreq = currblk->loopfreq;
	 
	 if (currblk->target[0] != '\0') {
	   if (currblk->target[0] != '.') {
	     if (currblk->succs != NULL) nextpath1 = currblk->succs->ptr->nr;
	     else nextpath1 = 0;
	     nextpath2 = 0;
	     strcpy(calledf,currblk->target);
	     call = TRUE;
	   }
	   else {
	     if (currblk->succs != NULL) nextpath1 = currblk->succs->ptr->nr;
	     else nextpath1 = 0;
	     if (currblk->succs->next != NULL) nextpath2 = currblk->succs->next->ptr->nr;
	     else nextpath2 = 0;
	   }
	 }
	 else {
	   if (currblk->succs != NULL) {
	     nextpath1 = currblk->succs->ptr->nr;
	     if (currblk->succs->next != NULL) nextpath2=currblk->succs->next->ptr->nr;
	     else nextpath2 = 0;
	   }
	   else nextpath1 = 0;
	 }
	 
	 if ((nextpath1>nextpath2)&&(nextpath2!=0)) {
	   temp = nextpath1;
	   nextpath1 = nextpath2;
	   nextpath2 = temp;
	 }


	 fprintf(outpath,"-1 _%s\n",funcname);
	 fprintf(outpath,"%d %d %d %d %d -1\n",thispath,loopno,loopfreq,instoffset,numinst);
	 if (call) {
	   fprintf(outpath,"1 _%s %d ",calledf,thispath);
	   if (nextpath1 != 0) fprintf(outpath,"%d",nextpath1);
	   fprintf(outpath,"\n");
	 }
	 else {
	   fprintf(outpath,"0 ");
	   if (nextpath1 != 0) {
	     fprintf(outpath,"%d ",nextpath1);
	     if (nextpath2 != 0) 	fprintf(outpath,"%d ",nextpath2);
	   }
	   fprintf(outpath,"-1 \n");
	 }
	 fprintf(outpath,"-1\n");

	 state = OTHER;	 
	 continue;
       }
     }
     break;

     case OTHER: {/*print out info about other paths */
       thispath = currblk->nr;
       instoffset =offset;
       numinst = currblk->num_inst;
       offset += (numinst*4);
       loopno = currblk->loopno;
       loopfreq = currblk->loopfreq;
       if (currblk->target[0] != '\0') {
	 if (currblk->target[0] != '.') {
	   if (currblk->succs!=NULL) nextpath1 = currblk->succs->ptr->nr;
	   else nextpath1 = 0;
	   nextpath2 = 0;
	   strcpy(calledf,currblk->target);
	   call = TRUE;
	 }
	 else {
	   if (currblk->succs != NULL) nextpath1 = currblk->succs->ptr->nr;
	   else nextpath1 = 0;
	   if (currblk->succs->next != NULL) nextpath2 = currblk->succs->next->ptr->nr;
	   else nextpath2 = 0;
	 }
       }
       else {
	 if (currblk->succs != NULL) {
	   nextpath1 = currblk->succs->ptr->nr;
	   if (currblk->succs->next!=NULL) nextpath2 = currblk->succs->next->ptr->nr;
	   else nextpath2 = 0;
	 }
	   else nextpath1 = 0;
       }
       
       if ((nextpath1>nextpath2)&&(nextpath2!=0)) {
	 temp = nextpath1;
	 nextpath1 = nextpath2;
	 nextpath2 = temp;
       }

       
       fprintf(outpath,"%d %d %d %d %d -1\n",thispath,loopno,loopfreq,instoffset,numinst);
       if (call) {
	 fprintf(outpath,"1 _%s %d ",calledf,thispath);
	   if (nextpath1!=0) fprintf(outpath,"%d",nextpath1);
	   fprintf(outpath,"\n");
	 }
       else {
	 fprintf(outpath,"0 ");
	 if (nextpath1 != 0) {
	   fprintf(outpath,"%d ",nextpath1);
	   if (nextpath2 != 0) 	fprintf(outpath,"%d ",nextpath2);
	   }
	 fprintf(outpath,"-1 \n");
       }

       state = OTHER;	 
       continue;
     }
     break;
     }//switch
   }
}

/*func to get the inf output */
void inf_info(FILE *outinf, FILE *loopin, struct bblock *top) {
  int state, i ,id;
  struct bblock *cur;
  struct blist *clist, *branch;
  struct instr *cinstr;
  char ch, dummy[MAXSTR], str[MAXSTR]="";
  char per = '%';
  int data_type, *list, num_blocks=0;
  char * wtf;
  state = FUNC;
  printf("\n");
  cur = NULL;
  clist = branch = NULL;
  cinstr = NULL;
  list = NULL;
  wtf = NULL;

  
  for(cur = top; cur; cur = cur->next) num_blocks++;

  list = (int *) malloc(num_blocks * sizeof(int));

  if (index(top->label,'.') != NULL) error("CFG is bad");
  fprintf(outinf,"-3\n%s\n",top->label);
  
  /*now read loop file and confirm that it has current function */
  fscanf(loopin,"%d",&i);
  if (i!=-3) error("loop file format error\n");
  fscanf(loopin," %s",dummy);
  if (strcmp(top->label, dummy)) error("wrong function order\n");

  /*now write the func info ie the first loop statement*/
  fprintf(outinf,"! loop 0 0 1 1 -1 -1 ");
  for (cur = top; cur; cur = cur->next) {
    fprintf(outinf,"%d ",cur->nr);
  }
  fprintf(outinf,"-1 ");
  for (i=0; i<top->numexits; i++) {
    fprintf(outinf,"%d ",top->exitpaths[i]);
  }
  fprintf(outinf,"-1\n");  


  /*check if the function has any loops and take care of them */
  fscanf(loopin," %c",&ch);
  while (ch!=EOF) {
    if (ch=='!') {
      fscanf(loopin," %s %d ",dummy, &id);
      fprintf(outinf,"! loop %d ",id);
      /*find a BB with loop info */
      for ( cur = top; cur; cur = cur->next) {
	if (cur->loop && cur->loopno==id) break;
      }
  
      if (cur == NULL) 
      {
	      printf("ERROR in inf_info\n") ;
	      assert(0) ;
      }
      else
      {
	// Else condition added by Sibin M on Feb 26, 2004.
      	/*print out the loop info */
      	fprintf(outinf, "%d ",cur->loopfreq);
      }
      ch='\0';
      fgets(str, MAXSTR-1,loopin);

      wtf = index(str,'\n');
      if (wtf!= NULL) *wtf = '\0';
      fprintf(outinf,"%s ",str);

      // Added by Sibin M on Feb 26, 2004. 
      // Check to see is 'cur' is NULL, before using it.
      if( cur != NULL )
      {
      		for (i=0; i<cur->loop_bno; i++) 
		{
			fprintf(outinf,"%d ",cur->loop_blocklist[i]);
      		}
      		fprintf(outinf,"-1 ");
      }
      else
      {
	      assert(0) ;
      }
      
      // Added by Sibin M on Feb 26, 2004. 
      // Check to see is 'cur' is NULL, before using it.
      if( cur != NULL )
      {
      		for (i=0; i<cur->numexits; i++) 
		{
			fprintf(outinf,"%d ",cur->exitpaths[i]);
      		}
      		fprintf(outinf,"-1\n");
      }
      else
	      assert(0) ;
    }
    else {
      ungetc(ch, loopin);
      break;
    }
    fscanf(loopin," %c",&ch);
  }
  
  /*take care of teh blocks */

  for (cur = top; cur; cur= cur->next) {
    fprintf(outinf,"! block %d lines 1-1 preds ",cur->nr);
    
    for (clist = cur->preds, num_blocks=0; clist; clist = clist->next, num_blocks++) {
      list[num_blocks] = clist->ptr->nr;
      //      fprintf(outinf,"%d ",clist->ptr->nr);
    }
    
    sort_list(list,num_blocks);
    for (i=0; i < num_blocks; i++) fprintf(outinf,"%d ",list[i]);
    
    fprintf(outinf,"-1 succs ");
    for (clist = cur->succs,num_blocks=0; clist; clist = clist->next,num_blocks++) {
      list[num_blocks] = clist->ptr->nr;
      //      fprintf(outinf,"%d ",clist->ptr->nr);
    }

    sort_list(list,num_blocks);
    for (i=0; i < num_blocks; i++) fprintf(outinf,"%d ",list[i]);

    fprintf(outinf,"-1\ndoms ");
    for (clist = cur->doms, num_blocks=0; clist; clist = clist->next, num_blocks++) {
      list[num_blocks] = clist->ptr->nr;
      //      fprintf(outinf,"%d ",clist->ptr->nr);
    }

    sort_list(list,num_blocks);
    for (i=0; i < num_blocks; i++) fprintf(outinf,"%d ",list[i]);
    
    fprintf(outinf,"-1\n");
    
    /*now get at the instruction list */
    for (cinstr = cur->instrs; cinstr;cinstr = cinstr->next) {
      cinstr->size = 0;
      
      data_type = cinstr->size;

      /*the datatype for op1 now has special meanign for branch instructions */
      if ((cinstr->opcode > 44 && cinstr->opcode < 65)) {
	/*check to see if it is backward or forward */
	for (branch = cur ->succs;branch; branch  = branch->next) {
	  if (branch->ptr->nr == cur->nr + 1) continue;
	  if (branch->ptr->nr > cur->nr) data_type = 100;/*forward*/
	  if (branch->ptr->nr < cur->nr) data_type = 50;/*back*/	  
	}
      }
      if ((cinstr->opcode == 30) ||
	  (cinstr->opcode == 31) ||
	  (cinstr->opcode == 70) ||
	  (cinstr->opcode == 73)) {
	data_type = 200;
      }



	  

#ifdef TRASH
      else if (cinstr->opcode == 110) data_type = 200;/*return*/
      else if (cinstr->opcode == 102) data_type = 200; /*call*/
      else if (cinstr->opcode == 101) data_type = 200; /*jump*/
      else if (cinstr->opcode == 111) data_type = 200; /*another jump*/
#endif
      /*XXXXXXXXXXXX*/
      /*      printf("%s %d %d \n",top->label,cinstr->BBid, cinstr->opcode);*/
      fprintf(outinf,"%d %d %d %d ",cinstr->BBid, cinstr->opcode, data_type,cinstr->cc);
      
      
      /*put in register info */
      /*format is -
	op_addr op_data_type op
	but op_addr is ignored */
      
      data_type = cinstr->size;
      
      if (cinstr->rs[0]!='\0') {
	if (isdigit(cinstr->rs[0]))
	  fprintf(outinf,"8 %d (%s) ",data_type, cinstr->rs);
	else fprintf(outinf,"8 %d (%c%s) ",data_type, per, cinstr->rs);
      }
      else if (cinstr->fs[0]!='\0') {
	fprintf(outinf,"8 %d (%c%s) ",data_type, per, cinstr->fs);
      }
      else fprintf(outinf,"8 %d () ",data_type);
      
      
      if (cinstr->rt[0]!='\0') {
	if (isdigit(cinstr->rt[0]))
	  fprintf(outinf,"8 %d (%s) ",data_type, cinstr->rt);
	else fprintf(outinf,"8 %d (%c%s) ",data_type, per, cinstr->rt);
      }
      else if (cinstr->ft[0]!='\0') {
	fprintf(outinf,"8 %d (%c%s) ",data_type, per, cinstr->ft);
      }
      else fprintf(outinf,"8 %d () ",data_type);
      
      if (cinstr->rd[0]!='\0') {
	if (isdigit(cinstr->rd[0]))
	  fprintf(outinf,"8 %d (%s) ",data_type, cinstr->rd);
	else fprintf(outinf,"8 %d (%c%s) ",data_type, per, cinstr->rd);
      }
      else if (cinstr->fd[0]!='\0') {
	fprintf(outinf,"8 %d (%c%s) ",data_type,per, cinstr->fd);
      }
      else fprintf(outinf,"8 %d () ",data_type);
      
    
      if (cinstr->opcode==30 || cinstr->opcode==32 ||
	  cinstr->opcode==33) 
	fprintf(outinf,"_%s ",cinstr->target);
      fprintf(outinf,"\n");
    }
  }
}
 
