#include <stdio.h>

#define MAXSTRING 256

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

/*
 * list of input lines
 */
struct line_s {
  char ln[MAXSTRING];
  struct line_s *next;
} *head = NULL;

/*
 * list of seen functions
 */
struct done_s {
  char func[MAXSTRING];
  int inst;
  struct done_s *next;
} *done = NULL;

int equal(struct done_s *f, struct done_s *g)
{
  return f == g || f && g && strcmp(f->func, g->func) == 0 && f->inst == g->inst;
}

int main(int argc, char *argv[])
{
  int on = FALSE;
  int inst;
  char parent[MAXSTRING];
  struct line_s *curr = NULL, *prev = NULL, *next = NULL;
  struct done_s *f = NULL, *g = NULL, h;

  /*
   * read in file from stdin
   */
  do {
    prev = curr;
    curr = (struct line_s *) malloc(sizeof(struct line_s));
    if (prev)
      prev->next = curr;
    curr->next = NULL;
    if (!head)
      head = curr;
  } while (fgets(curr->ln, MAXSTRING, stdin));

  /*
   * find a new function, print out all other lines of the same function
   */
  for (curr = head; curr; curr = curr->next) {
    if (!f)
      f = (struct done_s *) malloc(sizeof(struct done_s));
    if (strncmp(curr->ln, "-1", 2) != 0 ||
	sscanf(curr->ln, "-1 func %s instance %d parent %s",
	       f->func, &f->inst, parent) != 3)
      continue; /* not a function */

    for (g = done; g; g = g->next)
      if (equal(f, g))
	break;
    if (equal(f, g))
      continue; /* seen this function before */

    /*
     * found a new function, let's print its lines and later lines in the input
     */
    f->next = done;
    done = f;

    on = TRUE;
    printf("%s", curr->ln);
    for (next = curr->next; next; next = next->next) {
      if (strncmp(next->ln, "-1", 2) == 0 &&
	  sscanf(next->ln, "-1 func %s instance %d parent %s",
		 &h.func, &h.inst, parent) == 3)
	on = equal(f, &h);
      else if (on)
	printf("%s", next->ln);
    }
    f = NULL;
  }
}

